<template>
  <div>
    <div :class="componentClasses" data-testid="input-date" @click="focusInput">
      <input
        ref="input"
        v-model="currentValue"
        type="text"
        :placeholder="placeholder"
        :disabled="disabled"
        @change="inputChanged"
      />
      <sa-button
        text="Choose date"
        icon="calendar"
        size="small"
        icon-only
        :disabled="disabled"
        data-testid="button"
        @click="showPicker"
      />
    </div>
    <duet-date-picker
      ref="date"
      :identifier="uniqueId"
      data-testid="date-picker"
      @duetChange="dateSelected"
    />
  </div>
</template>

<script>
import dayjs from 'dayjs'
import SaButton from '@/components/button/SaButton'

const outputFormat = 'YYYY-MM-DD'
const displayFormat = 'DD/MM/YYYY'
const inputFormats = [
  displayFormat,
  'D/M/YYYY',
  'D/MM/YYYY',
  'DD/M/YYYY',
  outputFormat
]
const parseDateInput = (str) => dayjs(str, inputFormats)

export default {
  name: 'SaInputDate',
  components: { SaButton },
  props: {
    placeholder: { type: String, default: null },
    size: { type: String, default: 'regular' },
    disabled: { type: Boolean, default: false },
    inError: { type: Boolean, default: false },
    initialValue: { type: String, default: '' }
  },
  data({ initialValue }) {
    const initialDate = parseDateInput(initialValue)
    return {
      uniqueId: this.makeUniqueId(),
      currentValue: initialDate.isValid()
        ? initialDate.format(displayFormat)
        : initialValue,
      invalidDate: initialValue && !initialDate.isValid()
    }
  },
  computed: {
    componentClasses() {
      return [
        'sa-input-date',
        'input',
        this.size,
        (this.inError || this.invalidDate) && 'error',
        this.disabled && 'disabled',
        this.currentValue && 'active'
      ]
    }
  },
  mounted() {
    const date = parseDateInput(this.currentValue)
    if (date.isValid()) {
      this.$refs.date.value = date.format('YYYY-MM-DD')
    }
  },
  methods: {
    focusInput() {
      this.$refs.input.focus()
    },
    showPicker() {
      this.$refs.date.show()
    },
    dateSelected(event) {
      this.currentValue = dayjs(event.detail.value).format(displayFormat)
      this.invalidDate = false
      this.emitChange()
    },
    inputChanged() {
      if (!this.currentValue) {
        this.invalidDate = false
        this.emitChange()
        return
      }

      const date = parseDateInput(this.currentValue)
      if (date.isValid()) {
        this.$refs.date.value = date.format('YYYY-MM-DD')
        this.emitChange()
      }
      this.invalidDate = !date.isValid()
    },
    emitChange() {
      const date = parseDateInput(this.currentValue)
      if (date.isValid()) {
        this.$emit('change', date.format(outputFormat))
      } else if (!this.currentValue) {
        this.$emit('change', '')
      }
    }
  }
}
</script>

<style lang="scss">
:root {
  --duet-color-primary: #{color(primary)};
  --duet-color-text: #{color(primary-dark)};
  --duet-color-text-active: #{color(white)};
  --duet-color-button: #{color(white)};
  --duet-color-surface: #{color(white)};
  --duet-color-overlay: #{rgba(color(primary-dark), 0.8)};

  --duet-font: #{$font-family-primary};
  --duet-font-normal: #{$font-weight-regular};
  --duet-font-bold: #{$font-weight-regular};

  --duet-radius: #{$border-radius};
  --duet-z-index: 600;
}

.duet-date__input-wrapper {
  display: none;
}

.duet-date__dialog-content {
  margin-top: spacing(0);
  border: border(grey-light);
  box-shadow: $box-shadow;
}

.duet-date__dialog {
  transform: none;
  transition: none;

  &:not(.is-active) {
    display: none;
  }
}

.duet-date__day {
  margin-top: spacing(0);
  padding: 0;
  border-radius: $border-radius;
  &:hover::before,
  &.is-today::before {
    border-radius: $border-radius;
  }
}
</style>

<style scoped lang="scss">
input {
  flex: 1;
  /* focus highlight is moved to container */
  &:focus {
    outline: 0;
  }
}

button {
  margin-right: -#{spacing(1)};
}
</style>
